
# Notebooks

Jupyter Notebooks are documents that combine live runnable code, with narrative
text (markdown), equations (LaTeX), images, interactive visualizations and other
rich output:

[screenshot]

**Jupyter Notebook (.ipynb files) are fully supported in JupyterLab.**
Furthermore, the [notebook document
format](http://nbformat.readthedocs.io/en/latest/) used in JupyterLab is the
same as the classic notebook. Thus, your existing notebooks should work fine in
JupyterLab. If they don’t, please open an issue on our [GitHub
issues](https://github.com/jupyterlab/jupyterlab/issues) page.

Create a notebook by clicking the + button in the File Browser and then
selecting a kernel:

The user interface for Notebooks in JupyterLab closely follows that of the
classic Jupyter Notebook. The keyboard shortcuts of the classic Notebook
continue to work (with command and edit mode). However, a number of new things
are possible with notebooks in JupyterLab.

Drag and drop cells to rearrange your notebook:

[animation]

Drag cells between notebooks to quickly copy content:

[animation]

Create multiple, synchronized views of a single notebook:

[animation]

Collapse and expand code and output using the View Menu or the blue collapser
button on left of each cell:

[animation]

Create a new, synchronized view of a cell’s output:

[animation]

Tab completion (activated with the `Tab` key) now includes additional
information about the types of the matched items:

[animation]

The tooltip (activated with `Shift Tab`) contains additional information about
objects:

[animation]

